Wt: Wt::Form::Dbo::FormView< C > Class Template Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Private Member Functions | List of all members
Wt::Form::Dbo::FormView< C > Class Template Reference
Dbo Forms (Wt::Form)

A view class to represent database objects. More...

`#include <Wt/Form/Dbo/FormView.h>`

Inheritance diagram for Wt::Form::Dbo::FormView< C >:
[legend]

## Public Member Functions
| FormView (const Wt::WString &text)
| Constructor.
void | setFormModel (std::shared_ptr< FormModel< C > > model)
| Sets the form model.
void | setFormDelegate (Wt::WFormModel::Field field, std::shared_ptr< Wt::Form::WAbstractFormDelegate > delegate)
| Sets a custom form delegate.
std::unique_ptr< Wt::WWidget > | createFormWidget (Wt::WFormModel::Field field) override
| Creates a form widget.
void | updateModelValue (Wt::WFormModel *model, Wt::WFormModel::Field field, Wt::WFormWidget *edit) override
| Updates a value in the Model.
bool | updateModelValue (Wt::WFormModel *model, Wt::WFormModel::Field field, Wt::WWidget *edit) override
| Updates a value in the Model.
void | updateViewValue (Wt::WFormModel *model, Wt::WFormModel::Field field, Wt::WFormWidget *edit) override
| Updates a value in the View.
bool | updateViewValue (Wt::WFormModel *model, Wt::WFormModel::Field field, Wt::WWidget *edit) override
| Updates a value in the View.
void | save ()
| Saves the data to database.
const std::shared_ptr< FormModel< C > > & | model () const
| Returns the form model used by this class.
Public Member Functions inherited from Wt::WTemplateFormView
| WTemplateFormView ()
| Constructor.
| WTemplateFormView (const WString &text)
| Constructor.
void | setFormWidget (WFormModel::Field field, std::unique_ptr< WWidget > widget)
| Sets the form widget for a given field.
void | setFormWidget (WFormModel::Field field, std::unique_ptr< WWidget > widget, const std::function< void()> &updateViewValue, const std::function< void()> &updateModelValue)
| Sets the form widget for a given field.
virtual void | updateView (WFormModel *model)
| Updates the View.
virtual void | updateViewField (WFormModel *model, WFormModel::Field field)
| Creates or updates a field in the View.
virtual void | updateModel (WFormModel *model)
| Updates the Model.
virtual void | updateModelField (WFormModel *model, WFormModel::Field field)
| Updates a field in the Model.
Public Member Functions inherited from Wt::WTemplate
| WTemplate ()
| Creates a template widget.
| WTemplate (const WString &text)
| Creates a template widget with given template.
virtual WString | templateText () const
| Returns the template.
void | setTemplateText (const WString &text, TextFormat textFormat=TextFormat::XHTML)
| Sets the template text.
void | setWidgetIdMode (TemplateWidgetIdMode mode)
| Sets how the varName should be reflected on bound widgets.
TemplateWidgetIdMode | widgetIdMode () const
| Returns how the varName is reflected on a bound widget.
virtual void | bindString (const std::string &varName, const WString &value, TextFormat textFormat=TextFormat::XHTML)
| Binds a string value to a variable.
void | bindInt (const std::string &varName, int value)
| Binds an integer value to a variable.
virtual void | bindWidget (const std::string &varName, std::unique_ptr< WWidget > widget)
| Binds a widget to a variable.
template<typename Widget >
Widget * | bindWidget (const std::string &varName, std::unique_ptr< Widget > widget)
| Binds a widget to a variable, returning a raw pointer.
template<typename Widget , typename ... Args>
Widget * | bindNew (const std::string &varName, Args &&...args)
| Creates a new widget with the given arguments, and binds it, returning a raw pointer.
std::unique_ptr< WWidget > | removeWidget (const std::string &varName)
| Unbinds a widget by variable name.
virtual std::unique_ptr< WWidget > | removeWidget (WWidget *widget) override
| Unbinds a widget by widget pointer.
void | bindEmpty (const std::string &varName)
| Binds an empty string to a variable.
void | addFunction (const std::string &name, const Function &function)
| Binds a function.
void | setCondition (const std::string &name, bool value)
| Sets a condition.
virtual bool | conditionValue (const std::string &name) const
| Returns a condition value.
std::set< std::string > | conditionsSet ()
| Returns the set of conditions set to true.
virtual void | resolveString (const std::string &varName, const std::vector< WString > &args, std::ostream &result)
| Resolves the string value for a variable name.
virtual void | handleUnresolvedVariable (const std::string &varName, const std::vector< WString > &args, std::ostream &result)
| Handles a variable that could not be resolved.
virtual WWidget * | resolveWidget (const std::string &varName)
| Resolves a widget for a variable name.
virtual const WString & | resolveStringValue (const std::string &varName)
| Resolves a string that was bound to a variable name.
virtual bool | resolveFunction (const std::string &name, const std::vector< WString > &args, std::ostream &result)
| Resolves a function call.
template<typename T >
T | resolve (const std::string &varName)
| Returns a widget for a variable name.
virtual void | clear ()
| Erases all variable bindings.
void | setInternalPathEncoding (bool enabled)
| Enables internal path anchors in the XHTML template.
bool | hasInternalPathEncoding () const
| Returns whether internal paths are enabled.
void | setEncodeTemplateText (bool on)
| Configures when internal path encoding is done.
bool | encodeTemplateText () const
| Returns whether internal path encoding is done on the template text.
virtual void | refresh () override
| Refresh the widget.
virtual void | renderTemplate (std::ostream &result)
| Renders the template into the given result stream.
bool | renderTemplateText (std::ostream &result, const WString &templateText)
| Renders a template into the given result stream.
std::string | getErrorText ()
| Renders the errors during renderring.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
Public Member Functions inherited from Wt::WInteractWidget
| WInteractWidget ()
| Create an InteractWidget.
EventSignal< WKeyEvent > & | keyWentDown ()
| Event signal emitted when a keyboard key is pushed down.
EventSignal< WKeyEvent > & | keyPressed ()
| Event signal emitted when a "character" was entered.
EventSignal< WKeyEvent > & | keyWentUp ()
| Event signal emitted when a keyboard key is released.
EventSignal & | enterPressed ()
| Event signal emitted when enter was pressed.
EventSignal & | escapePressed ()
| Event signal emitted when escape was pressed.
EventSignal< WMouseEvent > & | clicked ()
| Event signal emitted when the primary mouse button was clicked on this widget.
EventSignal< WMouseEvent > & | doubleClicked ()
| Event signal emitted when the primary mouse button was double clicked on this widget.
EventSignal< WMouseEvent > & | mouseWentDown ()
| Event signal emitted when a mouse button was pushed down on this widget.
EventSignal< WMouseEvent > & | mouseWentUp ()
| Event signal emitted when a mouse button was released on this widget.
EventSignal< WMouseEvent > & | mouseWentOut ()
| Event signal emitted when the mouse went out of this widget.
EventSignal< WMouseEvent > & | mouseWentOver ()
| Event signal emitted when the mouse entered this widget.
EventSignal< WMouseEvent > & | mouseMoved ()
| Event signal emitted when the mouse moved over this widget.
EventSignal< WMouseEvent > & | mouseDragged ()
| Event signal emitted when the mouse is dragged over this widget.
EventSignal< WMouseEvent > & | mouseWheel ()
| Event signal emitted when the mouse scroll wheel was used.
EventSignal< WTouchEvent > & | touchStarted ()
| Event signal emitted when a finger is placed on the screen.
EventSignal< WTouchEvent > & | touchEnded ()
| Event signal emitted when a finger is removed from the screen.
EventSignal< WTouchEvent > & | touchMoved ()
| Event signal emitted when a finger, which is already placed on the screen, is moved across the screen.
EventSignal< WGestureEvent > & | gestureStarted ()
| Event signal emitted when a gesture is started.
EventSignal< WGestureEvent > & | gestureChanged ()
| Event signal emitted when a gesture is changed.
EventSignal< WGestureEvent > & | gestureEnded ()
| Event signal emitted when a gesture is ended.
void | setDraggable (const std::string &mimeType, WWidget *dragWidget=nullptr, bool isDragWidgetOnly=false, WObject *sourceWidget=nullptr)
| Configure dragging for drag and drop.
void | unsetDraggable ()
| Disable drag & drop for this widget.
void | setMouseOverDelay (int delay)
| Sets a delay for the mouse over event.
int | mouseOverDelay () const
| Returns the mouse over signal delay.
virtual void | setPopup (bool popup) override
| Lets the widget overlay over other sibling widgets.
virtual void | load () override
| Loads content just before the widget is used.
virtual bool | isEnabled () const override
| Returns whether the widget is enabled.
Public Member Functions inherited from Wt::WWebWidget
| WWebWidget ()
| Construct a WebWidget.
virtual std::vector< WWidget * > | children () const override
| Returns child widgets.
Signal & | childrenChanged ()
| Signal emitted when children have been added or removed.
virtual void | setPositionScheme (PositionScheme scheme) override
| Sets the CSS position scheme.
virtual PositionScheme | positionScheme () const override
| Returns the CSS position scheme.
virtual void | setOffsets (const WLength &offset, WFlags< Side > sides=AllSides) override
| Sets CSS offsets for a non-statically positioned widget.
virtual WLength | offset (Side s) const override
| Returns a CSS offset.
virtual void | resize (const WLength &width, const WLength &height) override
| Resizes the widget.
virtual WLength | width () const override
| Returns the width.
virtual WLength | height () const override
| Returns the height.
virtual void | setMinimumSize (const WLength &width, const WLength &height) override
| Sets a minimum size.
virtual WLength | minimumWidth () const override
| Returns the minimum width.
virtual WLength | minimumHeight () const override
| Returns the minimum height.
virtual void | setMaximumSize (const WLength &width, const WLength &height) override
| Sets a maximum size.
virtual WLength | maximumWidth () const override
| Returns the maximum width.
virtual WLength | maximumHeight () const override
| Returns the maximum height.
virtual void | setLineHeight (const WLength &height) override
| Sets the CSS line height for contained text.
virtual WLength | lineHeight () const override
| Returns the CSS line height for contained text.
virtual void | setFloatSide (Side s) override
| Specifies a CSS float side.
virtual Side | floatSide () const override
| Returns the CSS float side.
virtual void | setClearSides (WFlags< Side > sides) override
| Sets the sides that should be cleared of floats.
virtual WFlags< Side > | clearSides () const override
| Returns the sides that should remain empty.
virtual void | setMargin (const WLength &margin, WFlags< Side > sides=AllSides) override
| Sets CSS margins around the widget.
virtual WLength | margin (Side side) const override
| Returns a CSS margin set.
virtual void | setHiddenKeepsGeometry (bool enabled) override
| Sets whether the widget keeps its geometry when hidden.
virtual bool | hiddenKeepsGeometry () const override
| Returns whether the widget keeps its geometry when hidden.
virtual void | setHidden (bool hidden, const WAnimation &animation=WAnimation()) override
| Hides or shows the widget.
virtual bool | isHidden () const override
| Returns whether the widget is set hidden.
virtual bool | isVisible () const override
| Returns whether the widget is visible.
virtual void | setDisabled (bool disabled) override
| Sets whether the widget is disabled.
virtual bool | isDisabled () const override
| Returns whether the widget is set disabled.
virtual bool | isPopup () const override
| Returns whether the widget is overlayed.
virtual void | setInline (bool isInline) override
| Sets whether the widget is displayed inline or as a block.
virtual bool | isInline () const override
| Returns whether the widget is displayed inline or as block.
virtual void | setDecorationStyle (const WCssDecorationStyle &style) override
| Sets a CSS decoration style.
virtual WCssDecorationStyle & | decorationStyle () override
| Returns the decoration style of this widget.
virtual void | setStyleClass (const WString &styleClass) override
| Sets (one or more) CSS style classes.
virtual WString | styleClass () const override
| Returns the CSS style class.
virtual void | addStyleClass (const WString &styleClass, bool force=false) override
| Adds a CSS style class.
virtual void | removeStyleClass (const WString &styleClass, bool force=false) override
| Removes a CSS style class.
virtual bool | hasStyleClass (const WString &styleClass) const override
| Returns whether the widget has a style class.
virtual void | setVerticalAlignment (AlignmentFlag alignment, const WLength &length=WLength()) override
| Sets the vertical alignment.
virtual AlignmentFlag | verticalAlignment () const override
| Returns the vertical alignment.
virtual WLength | verticalAlignmentLength () const override
| Returns the fixed vertical alignment that was set.
virtual void | setToolTip (const WString &text, TextFormat textFormat=TextFormat::Plain) override
| Sets a tooltip.
virtual void | setDeferredToolTip (bool enable, TextFormat textFormat=TextFormat::Plain) override
| Enable deferred tooltip.
virtual WString | toolTip () const override
| Returns the tooltip.
virtual void | setAttributeValue (const std::string &name, const WString &value) override
| Sets an attribute value.
virtual WString | attributeValue (const std::string &name) const override
| Returns an attribute value.
virtual void | setJavaScriptMember (const std::string &name, const std::string &value) override
| Sets a JavaScript member.
virtual std::string | javaScriptMember (const std::string &name) const override
| Returns the value of a JavaScript member.
virtual void | callJavaScriptMember (const std::string &name, const std::string &args) override
| Calls a JavaScript member.
virtual bool | loaded () const override
| Returns whether this widget has been loaded.
virtual void | setId (const std::string &id) override
| Sets the CSS Id.
virtual WWidget * | find (const std::string &name) override
| Finds a descendent widget by name.
virtual WWidget * | findById (const std::string &id) override
| Finds a descendent widget by id.
virtual void | setSelectable (bool selectable) override
| Sets as selectable.
virtual void | doJavaScript (const std::string &javascript) override
| Executes the given JavaScript statements when the widget is rendered or updated.
virtual const std::string | id () const override
| Returns the (unique) identifier for this object.
void | setLoadLaterWhenInvisible (bool)
| Change the way the widget is loaded when invisible.
std::string | htmlTagName () const
| returns the current html tag name
void | setHtmlTagName (const std::string &tag)
| set the custom HTML tag name
virtual void | setCanReceiveFocus (bool enabled) override
| Sets whether the widget can receive focus.
virtual bool | canReceiveFocus () const override
| Returns whether the widget can receive focus.
virtual bool | setFirstFocus () override
| Set focus on the widget's first descendant.
virtual void | setFocus (bool focus) override
| Sets focus.
virtual bool | hasFocus () const override
| Returns whether the widget currently has the focus.
virtual void | setTabIndex (int index) override
| Sets the tab index.
virtual int | tabIndex () const override
| Returns the tab index.
EventSignal & | blurred ()
| Signal emitted when the widget lost focus.
EventSignal & | focussed ()
| Signal emitted when the widget recieved focus.
virtual bool | scrollVisibilityEnabled () const final override
| Returns whether scroll visibility detection is enabled for this widget.
virtual void | setScrollVisibilityEnabled (bool enabled) final override
| Sets whether scroll visibility detection is enabled for this widget.
virtual int | scrollVisibilityMargin () const final override
| Returns the margin around the viewport within which the widget is considered visible.
virtual void | setScrollVisibilityMargin (int margin) final override
| Sets the margin around the viewport within which the widget is considered visible.
virtual Signal< bool > & | scrollVisibilityChanged () final override
| Signal triggered when the scroll visibility of this widget changes.
virtual bool | isScrollVisible () const final override
| Returns whether this widget is currently considered scroll visible.
virtual void | setThemeStyleEnabled (bool enabled) final override
| Sets whether theme styling for a widget is enabled or disabled.
virtual bool | isThemeStyleEnabled () const final override
| Returns whether this widget is currently styled by the chosen theme.
virtual void | setObjectName (const std::string &name) override
| Sets an object name.
void | setFocus ()
| Sets focus.
Public Member Functions inherited from Wt::WWidget
virtual | ~WWidget ()
| Destructor.
WWidget * | parent () const
| Returns the parent widget.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
std::unique_ptr< WWidget > | removeFromParent ()
| Removes the widget from its parent.
void | setWidth (const WLength &width)
| Sets the width.
void | setHeight (const WLength &height)
| Sets the height.
virtual void | positionAt (const WWidget *widget, Orientation orientation=Orientation::Vertical)
| Positions a widget next to another widget.
virtual void | toggleStyleClass (const WString &styleClass, bool add, bool force=false)
| Toggles a CSS style class.
std::string | jsRef () const
| Returns a JavaScript expression to the corresponding DOM node.
void | setFocus ()
| Sets focus.
virtual void | acceptDrops (const std::string &mimeType, const WString &hoverStyleClass=WString())
| Sets a mime type to be accepted for dropping.
virtual void | stopAcceptDrops (const std::string &mimeType)
| Indicates that a mime type is no longer accepted for dropping.
virtual void | htmlText (std::ostream &out)
| Streams the (X)HTML representation.
bool | isRendered () const
| Returns whether the widget is rendered.
void | hide ()
| Hides the widget.
void | animateHide (const WAnimation &animation)
| Hides the widget using an animation.
void | show ()
| Shows the widget.
void | animateShow (const WAnimation &animation)
| Shows the widget using an animation.
void | enable ()
| Enables the widget.
void | disable ()
| Disable thes widget.
bool | layoutSizeAware () const
| Returns whether the widget is layout size aware.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
virtual std::string | objectName () const
| Returns the object name.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Protected Member Functions
virtual void | customizeFormWidget (Wt::WFormModel::Field field, Wt::WWidget *widget)
| Customize the auto generate form widget.
virtual void | customizeValidator (Wt::WFormModel::Field field, Wt::WValidator *validator)
| Customize the auto generated validator.
Wt::Signal & | saved ()
| Signal emitted when form is saved
Wt::Signal & | validationFailed ()
| Signal emitted when validation failed
Protected Member Functions inherited from Wt::WTemplateFormView
virtual void | indicateValidation (WFormModel::Field field, bool validated, WText *info, WWidget *edit, const WValidator::Result &validation)
| Indicates the validation result.
Protected Member Functions inherited from Wt::WTemplate
virtual void | applyArguments (WWidget *w, const std::vector< WString > &args)
| Applies arguments to a resolved widget.
void | format (std::ostream &result, const std::string &s, TextFormat textFormat=TextFormat::Plain)
| Utility method to safely format an XHTML string.
void | format (std::ostream &result, const WString &s, TextFormat textFormat=TextFormat::Plain)
| Utility method to safely format an XHTML string.
virtual void | enableAjax () override
| Progresses to an Ajax-enabled widget.
void | reset ()
| Notifies the template that it has changed and must be rerendered.
Protected Member Functions inherited from Wt::WInteractWidget
virtual void | propagateSetEnabled (bool enabled) override
| Propagates that a widget was enabled or disabled through children.
Protected Member Functions inherited from Wt::WWebWidget
virtual WStatelessSlot * | getStateless (Method method) override
| On-demand stateless slot implementation.
virtual void | render (WFlags< RenderFlag > flags) override
| Renders the widget.
Protected Member Functions inherited from Wt::WWidget
void | setLayoutSizeAware (bool sizeAware)
| Sets the widget to be aware of its size set by a layout manager.
virtual void | layoutSizeChanged (int width, int height)
| Virtual method that indicates a size change.
| WWidget ()
| Creates a widget.
virtual void | dropEvent (WDropEvent dropEvent)
| Handles a drop event.
virtual int | boxPadding (Orientation orientation) const
| Returns the widget's built-in padding.
virtual int | boxBorder (Orientation orientation) const
| Returns the widget's built-in border width.
void | scheduleRender (WFlags< RepaintFlag > flags=None)
| Schedules rerendering of the widget.
Protected Member Functions inherited from Wt::WObject

## Private Member Functions
std::unique_ptr< Wt::WWidget > | formWidget (Wt::WFormModel::Field field)
| Gets the widget generated by the form delegate.
std::shared_ptr< Wt::WValidator > | validator (Wt::WFormModel::Field field)
| Gets the validator generated by the form delegate.
std::shared_ptr< Wt::Form::WAbstractFormDelegate > | delegate (Wt::WFormModel::Field field)
| Gets the form delegate.

## Additional Inherited Members
Public Types inherited from Wt::WTemplate
typedef TemplateWidgetIdMode | WidgetIdMode
| Typedef for enum Wt::TemplateWidgetIdMode.
typedef std::function< bool(WTemplate *t, const std::vector< WString > &args, std::ostream &result)> | Function
| A function type.
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.
Static Public Member Functions inherited from Wt::WWebWidget
static std::string | jsStringLiteral (const std::string &v, char delimiter='\'')
| Turn a CharEncoding::UTF8 encoded string into a JavaScript string literal.
Static Public Member Functions inherited from Wt::WWidget
static WString | tr (const char *key)
| Short hand for WString::tr()
Static Public Member Functions inherited from Wt::WObject
Static Public Attributes inherited from Wt::WWidget
Protected Types inherited from Wt::WWebWidget
Protected Types inherited from Wt::WWidget
Protected Attributes inherited from Wt::WInteractWidget
Static Protected Attributes inherited from Wt::WInteractWidget
Static Protected Attributes inherited from Wt::WWidget

## Detailed Description

template<class C>
class Wt::Form::Dbo::FormView< C >

A view class to represent database objects.

This class takes the database object as a template argument. Instead of having to manually define all the widgets, the system will automatically generate default widgets based on the data type used in the database. For example: a `WString` object will by default be represented by a `WLineEdit` in the UI.

See also
  FormModel

## Constructor & Destructor Documentation

## ◆ FormView()

template<class C >

Wt::Form::Dbo::FormView< C >::FormView | ( | const Wt::WString & | text | ) |
| explicit

Constructor.

See also
  WTemplateFormView

## Member Function Documentation

## ◆ createFormWidget()

template<class C >

std::unique_ptr< Wt::WWidget > Wt::Form::Dbo::FormView< C >::createFormWidget | ( | Wt::WFormModel::Field | field | ) |
| overridevirtual

Creates a form widget.

This method is to ensure that the correct widget is used in the form for the given field, i.e. the widget defined by the form delegate.

See also
  WAbstractFormDelegate::createFormWidget

Reimplemented from Wt::WTemplateFormView.

## ◆ customizeFormWidget()

template<class C >

virtual void Wt::Form::Dbo::FormView< C >::customizeFormWidget | ( | Wt::WFormModel::Field | field,
|  | Wt::WWidget * | widget )
| protectedvirtual

Customize the auto generate form widget.

Allows derived classes to customize the automatically generated widget without having to customize an entire WFormDelegate.

For example: the default widget for WString objects is a WLineEdit. This method allows a derived class to set the input mask for a specific input field.

Base class implementation doesn't modify the widget

## ◆ customizeValidator()

template<class C >

virtual void Wt::Form::Dbo::FormView< C >::customizeValidator | ( | Wt::WFormModel::Field | field,
|  | Wt::WValidator * | validator )
| protectedvirtual

Customize the auto generated validator.

Allows derived classes to customize the automatically generated validator without having to customize an entire WFormDelegate.

For example: the default validator for integers is a WIntValidator. This method allows a derived class to specify the range for the validator.

Base class implementation doesn't modify the validator

## ◆ save()

template<class C >

void Wt::Form::Dbo::FormView< C >::save | ( |  | ) |

Saves the data to database.

First the data is validated. If the data in the model is valid, the data will be pushed to the database. If not, the validationFailed() signal will be emitted. On succesful save, the saved() signal will be emitted.

## ◆ setFormDelegate()

template<class C >

void Wt::Form::Dbo::FormView< C >::setFormDelegate | ( | Wt::WFormModel::Field | field,
|  | std::shared_ptr< Wt::Form::WAbstractFormDelegate > | delegate )

Sets a custom form delegate.

Overrides the default delegate for a given field

Exceptions

  WException | when this function is called after setFormModel

## ◆ setFormModel()

template<class C >

void Wt::Form::Dbo::FormView< C >::setFormModel | ( | std::shared_ptr< FormModel< C > > | model | ) |

Sets the form model.

This method will automatically generate the form delegates and set the form widgets and model validators.

See also
  customizeFormWidget, customizeValidator

## ◆ updateModelValue() [1/2]

template<class C >

void Wt::Form::Dbo::FormView< C >::updateModelValue | ( | Wt::WFormModel * | model,
|  | Wt::WFormModel::Field | field,
|  | Wt::WFormWidget * | edit )
| overridevirtual

Updates a value in the Model.

The default implementation first calls updateModelValue(WFormModel *, WFormModel::Field, WWidget *). If that returns false, it will then call the updateModelValue function of WAbstractFormDelegate if there's a delegate defined for this field. If not, it will call the function of WTemplateFormView.

Reimplemented from Wt::WTemplateFormView.

## ◆ updateModelValue() [2/2]

template<class C >

bool Wt::Form::Dbo::FormView< C >::updateModelValue | ( | Wt::WFormModel * | model,
|  | Wt::WFormModel::Field | field,
|  | Wt::WWidget * | edit )
| overridevirtual

Updates a value in the Model.

The default implementation calls the updateModelValue function of WAbstractFormDelegate if there's a delegate defined for this field. If not, it will call the function of WTemplateFormView.

Reimplemented from Wt::WTemplateFormView.

## ◆ updateViewValue() [1/2]

template<class C >

void Wt::Form::Dbo::FormView< C >::updateViewValue | ( | Wt::WFormModel * | model,
|  | Wt::WFormModel::Field | field,
|  | Wt::WFormWidget * | edit )
| overridevirtual

Updates a value in the View.

The default implementation first calls updateViewValue(WFormModel *, WFormModel::Field, WWidget *). If that returns false, it will then call the updateViewValue function of WAbstractFormDelegate if there's a delegate defined for this field. If not, it will call the function of WTemplateFormView.

Reimplemented from Wt::WTemplateFormView.

## ◆ updateViewValue() [2/2]

template<class C >

bool Wt::Form::Dbo::FormView< C >::updateViewValue | ( | Wt::WFormModel * | model,
|  | Wt::WFormModel::Field | field,
|  | Wt::WWidget * | edit )
| overridevirtual

Updates a value in the View.

The default implementation calls the updateViewValue function of WAbstractFormDelegate if there's a delegate defined for this field. If not, it will call the function of WTemplateFormView.

Reimplemented from Wt::WTemplateFormView.

## ◆ validationFailed()

template<class C >

Wt::Signal & Wt::Form::Dbo::FormView< C >::validationFailed | ( |  | ) |
| protected

Signal emitted when validation failed

This can be emitted when saving the form. The save action will have failed because some fields are invalid.